<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Error Handling</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Error Handling</h1>    
                    </section>
                    <section>
                        <h2>Error Handling Overview</h2>
                        <ul>
                            <li>General Considerations</li>
                            <li>Assert.h</li>
                            <li>Errno.h</li>
                            <li>Assert Vs. Errno</li>
                            <li>I/O Functions</li>
                            <li>Mathematical Functions</li>
                            <li>Pointers</li>
                            <li>Strings</li>
                            <li>Files</li>
                        </ul>
                    </section>
                    <section>
                        <h2>General Considerations</h2>
                        <p>What can you do in the event of an error?</p>
                        <ul>
                            <li>Retry</li>
                            <li>Ignore</li>
                            <li>Abort (Return/Exit)</li>
                        </ul>
                    </section>
                </section>
                <!-- Assert Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">   
                    <section>
                        <h1>Assert.h</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <h2>What is Assert?</h2>
                        <ul>
                            <li>Part of the standard C Library</li>
                            <li>Behaves like a macro</li>
                            <li>A debugging aid</li>
                        </ul>
                    </section>

                    <section>
                        <h2>assert.h</h2>
                        <p> assert() is defined as:</p>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
    // If the constant MACRO NDEBUG is not defined
    void assert(int expression);
    
    // Otherwise
    #define assert(e) ((void)0)
                        </span></code></pre>
                        <aside class="notes">
                            Notes go here
                        </aside>
                    </section>

                    <section>
                        <h2> Assertion types</h2>
                        <ul>
                            <li>Preconditions</li>
                            <li>Postconditions</li>
                            <li>Invariants</li>
                        </ul>
                        <aside class="notes">
                            PRECONDITIOINS-specify conditions at the start of the function.
                            POSTCONDITIONS-Specify conditions at the end of a function.
                            INVARIANTS-Specify conditions over a defined region of a program.
                        </aside>
                    </section>

                    <section>
                        <h2>Common Preconditions</h2>
                        <ul>
                            <li>Pointers are not NULL</li>
                            <li>Indexes and size values are non-negative</li>
                            <li>Indexes and size values are less than an established limit</li>
                        </ul>
                        <aside class="notes">
                            PRECONDITIOINS-specify conditions at the start of the function.
                            POSTCONDITIONS-Specify conditions at the end of a function.
                            INVARIANTS-Specify conditions over a defined region of a program.
                        </aside>
                    </section>

                    <section>
                        <h2> Common Postconditions</h2>
                        <ul>
                            <li>Expected return values</li>
                            <li>Proper output</li>
                        </ul>
                        <aside class="notes">
                            PRECONDITIOINS-specify conditions at the start of the function.
                            POSTCONDITIONS-Specify conditions at the end of a function.
                            INVARIANTS-Specify conditions over a defined region of a program.
                        </aside>
                    </section>

                    <section>
                        <h2>When to Assert</h2>
                        <ul>
                            <li>Program errors (Bugs)</li>
                            <ul>
                                <li>Larger programs may have some bugs</li>
                                <li>Bad code or failed functions can create bugs.</li>
                                <li>Use assert to handle program errors</li>
                            </ul>
                        </ul>
                        <aside class="notes">
                            PRECONDITIOINS-specify conditions at the start of the function.
                            POSTCONDITIONS-Specify conditions at the end of a function.
                            INVARIANTS-Specify conditions over a defined region of a program.
                        </aside>
                    </section>

                    <section>
                        <h2>When *not* to assert</h2>
                        <ul>
                            <li>Runtime errors (Bad Input)</li>
                            <ul><li>Use error checking instead</li></ul>
                        </ul>
                    </section>

                    <section>
                        <h2>Syntax</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
void assert (expression)
// If Expression is true, nothing happens
// else, assert prints an error to stderr, terminates the program
// and closes the stream</span></code></pre>
                        <aside class="notes">
                        </aside>
                    </section>

                    <section>
                        <h3>Example 1</h3>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">//////////////ASSERT EXAMPLE 1///////////////////

#include &ltassert.h&gt     //defines assert()

#include &ltstdlib.h&gt     //defines calloc()
#include &ltstdio.h&gt      //defines string-related functions

int main(void)
{
    // string pointer
    char * dynamicString = NULL;
    // dynamic string
    dynamicString = calloc(20, sizeof(char));

    // assert that dynamicString is not NULL
    assert(dynamicString);
    
    // read a string
    fgets(dynamicString, 20, stdin);

    // assert that the string is nul terminated
    assert(dynamicString[19] == '\0');

    // print the string
    puts(dynamicString);
    return 0;
 }</code></pre></div></div>
                    </section>
                    <section>
                        <h3>Example 2</h3>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">// ASSERT EXAMPLE 2

#include &ltassert.h&gt     //defines assert()
#include &ltstdio.h&gt      //defines string-related functions

int main(void)
{
    int numerator, denominator;
    float result;
    puts("Enter two numbers to divide (ex. 5 / 3)");
    scanf("%d / %d", &numerator, &denominator);

    // assert that the denominator is not 0
    assert(denominator);

    result = (float)numerator / denominator;
    // print the string
    printf("Result: \t%.2f", result);
    return 0;
}</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Demonstration Lab</h1>
                    </section>
                    <section>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
#define _CRT_SECURE_NO_WARNINGS 1
#ifndef _DEBUG
#define NDEBUG
#endif
#include &ltstdio.h&gt
#include &ltassert.h&gt
#include &ltstdlib.h&gt
//#define STEP1
#define BUF_SIZE 16

int main(void)
{
    char * inputString = (char *)calloc(BUF_SIZE, sizeof(char));
    assert(inputString);			// Assert that inputString is not NULL

#ifdef STEP1
    // Do step1 stuff here
    fgets(inputString, BUF_SIZE, stdin);
#else
    // Do other non-step1 stuff here
    scanf("%s", inputString);
#endif
    assert(inputString[BUF_SIZE - 1] == '\0');
    puts(inputString);
    return 0;
}</code></pre></div></div>
                    </section>
                    <section>
                        <h2>Questions</h2>
                        <ol>
                            <li>Does this program use fgets or scanf?</li>
                            <li>What type of issue is assert looking for?</li>
                        </ol>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Performance Lab - Walk the String</h2>
                    </section>
                </section>
                <!-- Errno Section -->
                <section>
                    <section>
                        <h1>Errno</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <h2>errno.h</h2>
                        <ul>
                            <li>An stores an error value to memory</li>
                            <li>Programs can check the value or ERRNO</li>
                        </ul>
                        <aside class="notes">
                            The errno.h header file supports an error-reporting mechanism. This mechanism provides an external static memory location (ERRNO).
                            Some library functions place a value in this memory location to report an error. A program, or functions in this header file, 
                            can check the value of ERRNO.
                        </aside>
                    </section>

                    <section>
                        <h2>Example Errno Values</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
FILE * missingFile = fopen(“Z:\\Missing.txt”, “r”);
// errno == ENOENT == 2 /* No such file or directory */

char * missingPointer = malloc(9999999999999999999);
// errno == ENOMEM == 12 /* Out of memory */

FILE * lockedFile = fopen(“C:\\Windows\\Notepad.exe”, “w”);
// errno == EACCESS == 13 /* Permission denied */

FILE * badFileName = fopen(“C:\\Temp\\!@#$%^&*.txt”, “w+”);
// errno == EINVAL == 22 /* Invalid argument */

float imaginaryNumber = sqrt(-1);
// errno == EDOM == 33 /* Math argument out of domain of func */</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Errno Uses</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int feof(FILE *stream)
// Tests the end-of-file indicator for “stream”, non-0 if set

int ferror(FILE *stream)
// Tests the error indicator for the “stream”, non-0 if set 

void clearerr(FILE *stream)
// Clears the end-of-file and error indicators for “stream”

void perror(const char *s)
// Print a system error message to standard error

return &ltn>
// Specify &ltn> as the errno to provide the nature of error

char *strerror(int errnum)
// Returns a string describing the error number
</code></pre></div></div>
                    </section>

                    <section>
                        <h3>Pro-Tip</h3>
					    <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
// -1 typically an error
if (myFunc() == -1)			
{
    // Save errno
    currentErrno = errno;	
    // Provide feedback	
	printf(“myFunc() failed!”);	
}</span></code></pre>
                        <aside class="notes">
                            add notes here
                        </aside>
                    </section>

                    <section>
                        <h3>Common Mistake</h3>
                        <pre>            <code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
// -1 is typically an error
if (myFunc() == -1) 			
{
    // printf may update errno
    printf(“myFunc() failed!”);	
    // Errno wasn't preserved
    currentErrno = errno;		
}
                        </span></code></pre>
                        <aside class="notes">
                            add notes here
                        </aside>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">

                    <section>
                        <h2>Demonstration Lab</h2>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Performance Lab - Errno</h2>
                    </section>
                </section>

                <!-- Asset and Errno Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                
                    <section>
                        <h2>Asset and Errno</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                
                    <section>
                        <h2><b>Assert</b> vs Errno</h2>
                        <p>Assert checks for errors that shouldn't happen.</p>
                        <ul>
                            <li>Valid range of values</li>
                            <li>Specific values</li>
                            <li>Design by contract</li>
                            <li>NULL pointers (when the pointer shouldn't be null)</li>
                        </ul>
                        <aside class="notes">
                            Errno on next slide
                        </aside>
                    </section>
    
                    <section>
                        <h2>Assert vs <b>Errno</b></h2>
                        <ul>
                            <li>Returns from system calls and library functions</li>
                            <li>User Input Data</li>
                            <li>Network Input Data</li>
                            <li>File Input Data</li>
                            <li>Out of System Resources</li>
                        </ul>
                        <aside class="notes">
                            Assert on previous slide
                            I/O functions typically return useful values
                            Many I/O functions update ERRNO
                        </aside>
                    </section>
                
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">

                    <section>
                        <h2>Demonstration Lab</h2>
                    </section>

                    <section>
                        <h2>Instructions</h2>
                        <p>Use appropriate error handling (assert vs errno) to handle I/O errors.<br><br>
                            Replicate the error to test your implementations.</p>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
#define _CRT_SECURE_NO_WARNINGS 1
#ifndef _DEBUG
#define NDEBUG
#endif
#include &ltstdio.h&gt
#include &ltassert.h&gt
#include &ltstdlib.h&gt
//#define STEP1
#define BUF_SIZE 16

int main(void)
{
    char * inputString = (char *)calloc(BUF_SIZE, sizeof(char));
    assert(inputString);			// Assert that inputString is not NULL

#ifdef STEP1
    // Do step1 stuff here
    fgets(inputString, BUF_SIZE, stdin);
#else
    // Do other non-step1 stuff here
    scanf("%s", inputString);
#endif
    assert(inputString[BUF_SIZE - 1] == '\0');
    puts(inputString);
    return 0;
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Performance Lab - Output!</h2>
                    </section>
                </section>

                <!-- Errorss Section -->
                <section>
                    <section>
                        <h2>Errors to Handle</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                    <section>
                        <h2>Possible Math Errors</b></h2>
                        <ul>
                            <li>Divide by 0</li>
                            <li>NaN</li>
                            <li>Overflow</li>
                            <li>Underflow</li>
                            <li>Imaginary numbers</li>
                            <li>Infinite Calculations</li>
                        </ul>
                        <aside class="notes">
                            Overflow (a number becomes too large for the computer to handle), underflow the opposite.
                            math.h and HUGE_VAL represents when something isn't representable as a floating point.
                        </aside>
                    </section>
    
                    <section>
                        <h2>Null Pointers</b></h2>
                        <p>Never Dereference a null pointer. Always check for null pointers.</p>
                        <aside class="notes">
                            Never dereference a null pointer.
                        </aside>
                    </section>
    
                    <section>
                        <p>WWE Hall of Famer Bret Hart on Dereferencing Null Pointers</p>
                        <iframe width="560" height="315" src="https://www.youtube.com/embed/bLHL75H_VEM" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture"></iframe>
                    </section>
                    
                    <section>
                        <h2>Strings</h2>
                        <p>Many string functions update ERRNO.</p>
                        <aside class="notes">
                            Never dereference a null pointer.
                        </aside>
                    </section>
    
                    <section>
                        <h2>Strings</h2>
                        <p>Make sure your strings are null-terminated.</p>
                        <aside class="notes">
                            Never dereference a null pointer.
                        </aside>
                    </section>
    
                    <section>
                        <h2>Files</h2>
                        <ul>
                            <li>Permission Errors</li>
                            <li>FILE is a pointer</li>
                            <li>Missing files in certain modes</li>
                        </ul>
                    </section>

                </section>

                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>General Considerations</li>
                            <li>Assert.h</li>
                            <li>Errno.h</li>
                            <li>Assert Vs. Errno</li>
                            <li>I/O Functions</li>
                            <li>Mathematical Functions</li>
                            <li>Pointers</li>
                            <li>Strings</li>
                            <li>Files</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
